;; -*- lexical-binding: t -*-

(defmacro time-it (&rest forms)
  "Return seconds taken to evaluate FORMS."
  `(let ((start (current-time)))
     ,@forms
     (float-time (time-subtract nil start))))

(defun time-scroll (&optional arg)
  (interactive "P")
  (with-temp-buffer
    (insert (number-to-string
             (time-it
              (ignore-errors
                (while t
                  (if arg (scroll-down) (scroll-up))
                  (sit-for 0)))))
            ?\n)
    (let ((file (format "/tmp/timings-%d.txt" emacs-major-version)))
      (write-region nil nil file t 0)))
  (kill-emacs))

;; Always use same version.
(find-file "~/.local/src/emacs/src/xdisp.c")
(run-at-time 2 nil #'time-scroll)
